/*  libim - Library of Instant Messaging and Presence enabler
 * imerror.h - 
 *
 * Authors: ZHAO Liangjing <liangjing.zhao@orange-ftgroup.com> 
 * 
 * This software and associated documentation files (the "Software") 
 * are copyright (C) 2005 LiPS Linux Phone Standards Forum [FranceTelecom] 
 * All Rights Reserved. 
 *
 * A copyright license is hereby granted for redistribution and use of 
 * the Software in source and binary forms, with or without modification, 
 * provided that the following conditions are met: 
 * - Redistributions of source code must retain the above copyright notice, 
 * this copyright license and the following disclaimer. 
 * - Redistributions in binary form must reproduce the above copyright 
 * notice, this copyright license and the following disclaimer in the 
 * documentation and/or other materials provided with the distribution. 
 * - Neither the name of LiPS  nor the names of its Members may be used 
 * to endorse or promote products derived from the Software without 
 * specific prior written permission. 
 *
 * A patent license for any Necessary Claims owned by Members of LiPS Forum 
 * to make, have made, use, import, offer to sell, lease and sell or otherwise 
 * distribute any implementation compliant with the any specification adopted 
 * by the LiPS Forumcan be obtained from the respective Members on reasonable 
 * and non-discriminatory terms and conditions and under reciprocity, as 
 * regulated in more detail in the Internal Policy of the LiPS Forum. 
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER, ITS MEMBERS AND CONTRIBUTORS 
 * "AS IS", AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, 
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE 
 * AND NON-INFRINGEMENT ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER, 
 * ITS MEMBERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
 * POSSIBILITY OF SUCH DAMAGE. 
 */


/**
 *@file imerror.h
 *API definition of the Instance Message Interface - Error
 *
 *@version 0.1
 */

#ifndef __LIPS_IM_ERROR_H
#define __LIPS_IM_ERROR_H

#ifdef __cplusplus
extern "C"
{
#endif                          /* __cplusplus */

  /**
   *@ingroup LiPS_IM_API
   *@brief IM Error definition
   *
   *The error code of im enabler is in the range from -4001 to -5000
   */
  typedef enum
  {
    IM_ERROR_NONE = 0,          ///< No error.
    IM_ERROR_ALREADY_DONE,      ///< Already done.
    IM_ERROR_GENERAL = -4900,   ///< Error no specified.
    IM_ERROR_WRONG_SID,         ///< Wrong sid.
    IM_ERROR_WRONG_URI,         ///< Wrong URI.
    IM_ERROR_NOMEM,             ///< No memory.
    IM_ERROR_NULL,              ///< Pointer is NULL.
    IM_ERROR_NETWORK,           ///< Socket error.
    IM_ERROR_NETWORK_STATE,     ///< Network status error.
    IM_ERROR_LOGINED,           ///< Already logined.
    IM_ERROR_NOSUPPORT,         ///< Operation isn't supported.
    IM_ERROR_PASSWORD,          ///< Password error.
    IM_ERROR_DUPLICATE,         ///< Operation causes an duplication.
    IM_ERROR_PARAM,             ///< Wrong parameters.
    IM_ERROR_DBUS               ///< Dbus error.
  } im_err_t;

#ifdef __cplusplus
}
#endif                          /* __cplusplus */

#endif                          /* __LIPS_IM_ERROR_H */

