/*  libim - Library of Instant Messaging and Presence enabler
 * im_dbus.h - 
 *
 * Authors: ZHAO Liangjing <liangjing.zhao@orange-ftgroup.com> 
 * 
 * This software and associated documentation files (the "Software") 
 * are copyright (C) 2005 LiPS Linux Phone Standards Forum [FranceTelecom] 
 * All Rights Reserved. 
 *
 * A copyright license is hereby granted for redistribution and use of 
 * the Software in source and binary forms, with or without modification, 
 * provided that the following conditions are met: 
 * - Redistributions of source code must retain the above copyright notice, 
 * this copyright license and the following disclaimer. 
 * - Redistributions in binary form must reproduce the above copyright 
 * notice, this copyright license and the following disclaimer in the 
 * documentation and/or other materials provided with the distribution. 
 * - Neither the name of LiPS  nor the names of its Members may be used 
 * to endorse or promote products derived from the Software without 
 * specific prior written permission. 
 *
 * A patent license for any Necessary Claims owned by Members of LiPS Forum 
 * to make, have made, use, import, offer to sell, lease and sell or otherwise 
 * distribute any implementation compliant with the any specification adopted 
 * by the LiPS Forumcan be obtained from the respective Members on reasonable 
 * and non-discriminatory terms and conditions and under reciprocity, as 
 * regulated in more detail in the Internal Policy of the LiPS Forum. 
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER, ITS MEMBERS AND CONTRIBUTORS 
 * "AS IS", AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, 
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE 
 * AND NON-INFRINGEMENT ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER, 
 * ITS MEMBERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
 * POSSIBILITY OF SUCH DAMAGE. 
 */


/**
 *@file API definition of the Instance Message Interface - IM DBus definition
 *
 *@version 0.1
 */

#ifndef __LIPS_IM_DBUS_H
#define __LIPS_IM_DBUS_H

#define IM_DBUS_SERVICE "org.lips.enabler.im"
#define IM_DBUS_INTERFACE "org.lips.im.enabler.improxy"
#define IM_DBUS_OBJECT "/org/lips/enabler/im/server"

#define IM_CLIENT_SERVICE "org.lips.enabler.imclientdemo"
#define IM_CLIENT_INTERFACE "org.lips.enabler.imevent"
#define IM_CLIENT_OBJECT "/org/lips/enabler/imclientdemo/client"

#define IM_DBUS_CALL_DELAY 20000000

#define IM_DBUS_MSG_OPEN_SESSION "IM_Open_Session"
#define IM_DBUS_MSG_CLOSE_SESSION "IM_Close_Session"
#define IM_DBUS_MSG_QUIT "IM_Proxy_Quit"
#define IM_DBUS_MSG_REG "IM_Event_Reg"
#define IM_DBUS_MSG_UNREG "IM_Event_Unreg"
#define IM_DBUS_MSG_LOGIN "IM_Req_Login"
#define IM_DBUS_MSG_LOGOUT "IM_Req_Logout"
#define IM_DBUS_MSG_CHANGE_PRESENCE "IM_Req_Change_Presence"
#define IM_DBUS_MSG_PRESENCE_PROBE "IM_Req_Presence_Probe"
#define IM_DBUS_MSG_SUBSCRIBE "IM_Req_Subscribe"
#define IM_DBUS_MSG_SENDMSG "IM_Req_Sendmsg"
#define IM_DBUS_MSG_ACCEPT "IM_Req_Accept"
#define IM_DBUS_MSG_GET_ROSTER "IM_Req_Get_Roster"
#define IM_DBUS_MSG_BUDDY "IM_Req_Buddy"
#define IM_DBUS_MSG_SYNCH "IM_Req_Synch"
#define IM_DBUS_MSG_STATE "IM_Req_State"

#define IM_CLIENT_MSG_EVT_IN "IM_C_Incoming_Evt"

#define IM_DBUS_LOG_FILE "/tmp/im_proxy.log"

#include <dbus/dbus.h>
#include <dbus/dbus-glib.h>
#include "dbus-if.h"

#ifdef __cplusplus
extern "C"
{
#endif                          /* __cplusplus */

#ifdef __cplusplus
}
#endif                          /* __cplusplus */

#endif /* __LIPS_IM_DBUS_H*/

