/*  libim - Library of Instant Messaging and Presence enabler
 * imevent_imp.h -
 *
 * Authors: ZHAO Liangjing <liangjing.zhao@orange-ftgroup.com>
 *
 * This software and associated documentation files (the "Software")
 * are copyright (C) 2005 LiPS Linux Phone Standards Forum [FranceTelecom]
 * All Rights Reserved.
 *
 * A copyright license is hereby granted for redistribution and use of
 * the Software in source and binary forms, with or without modification,
 * provided that the following conditions are met:
 * - Redistributions of source code must retain the above copyright notice,
 * this copyright license and the following disclaimer.
 * - Redistributions in binary form must reproduce the above copyright
 * notice, this copyright license and the following disclaimer in the
 * documentation and/or other materials provided with the distribution.
 * - Neither the name of LiPS  nor the names of its Members may be used
 * to endorse or promote products derived from the Software without
 * specific prior written permission.
 *
 * A patent license for any Necessary Claims owned by Members of LiPS Forum
 * to make, have made, use, import, offer to sell, lease and sell or otherwise
 * distribute any implementation compliant with the any specification adopted
 * by the LiPS Forumcan be obtained from the respective Members on reasonable
 * and non-discriminatory terms and conditions and under reciprocity, as
 * regulated in more detail in the Internal Policy of the LiPS Forum.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER, ITS MEMBERS AND CONTRIBUTORS
 * "AS IS", AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE
 * AND NON-INFRINGEMENT ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER,
 * ITS MEMBERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */

/**
 *@file API definition of the Instance Message Interface - Events Implementation
 *
 *@version 0.1
 *@author ZHAO Liangjing
 */

#ifndef __LIPS_IM_EVENT_IMP_H
#define __LIPS_IM_EVENT_IMP_H

#include "imevent.h"

#ifdef __cplusplus
extern "C"
{
#endif                          /* __cplusplus */

  /**
   *@ingroup LiPS_IM_API
   *@var evt_src_t *im_evt_src
   *@brief event source for IM enabler.
   */
  extern evt_src_t *im_evt_src;

  /**
   *@brief the evt_get_t inmplementation of IM enabler.
   *
   *get an im event structure.
   *
   *@param evt_src the event source.
   *@param sid the session id.
   *@param[out] evt a pointer to return the event structure.
   *@param timeout timeout duration.
   *
   *@return an evt_err_t value.
   */
  evt_err_t im_evt_get (evt_src_t *evt_src,
                        sid_t sid, evt_t **evt, int timeout);

  /*
   *@brief the evt_release_t implementation of IM enabler.
   *
   *release an im event structure.
   *
   *@param evt_src the event source.
   *@param evt the event will be released.
   *@return an evt_err_t value.
   */
//   evt_err_t im_evt_release(evt_src_t *evt_src,
//                            evt_t*evt);

#ifdef __cplusplus
}
#endif                          /* __cplusplus */

#endif                          /* __LIPS_IM_EVENT_IMP_H */

