/*  libim - Library of Instant Messaging and Presence enabler
 * imsession.h - 
 *
 * Authors: ZHAO Liangjing <liangjing.zhao@orange-ftgroup.com> 
 * 
 */


/**
 *@file API definition of the Instance Message Interface - IM Session
 *
 *@version 0.1
 */

#ifndef __LIPS_IM_SESSION_H
#define __LIPS_IM_SESSION_H

#include "imtype_imp.h"
#include "imconnect.h"
#include "imevent.h"

#ifdef __cplusplus
extern "C"
{
#endif                          /* __cplusplus */

  typedef struct _im_session_t im_session_t;
  typedef struct _im_trans_t im_trans_t;

  extern im_list *bad_sessions;

  struct _im_session_t
  {
    im_sid_t sid;
    char *client_name;
    im_connection *conn;
    im_list *evt_type_list;     ///< Registered event type.
  };

  im_session_t *im_session_new (im_sid_t sid, char *client_name);

  void im_session_free (im_session_t *session);

  im_sid_t im_session_get_sid (im_session_t *session);

  char *im_session_get_client_name (im_session_t *session);

  im_connection *im_session_get_conn (im_session_t *session);

  im_err_t im_session_reg_evt (im_session_t *session, im_evt_type_t type);

  im_err_t im_session_unreg_evt (im_session_t *session, im_evt_type_t type);

  bool im_session_is_registered (im_session_t *session, im_evt_type_t type);

  void im_session_send_evt (im_trans_t *t);

#ifdef __cplusplus
}
#endif                          /* __cplusplus */

#endif /* __LIPS_IM_SESSION_H*/

