/*  libim - Library of Instant Messaging and Presence enabler
 * imtype_imp.h - 
 *
 * Authors: ZHAO Liangjing <liangjing.zhao@orange-ftgroup.com> 
 * 
 * This software and associated documentation files (the "Software") 
 * are copyright (C) 2005 LiPS Linux Phone Standards Forum [FranceTelecom] 
 * All Rights Reserved. 
 *
 * A copyright license is hereby granted for redistribution and use of 
 * the Software in source and binary forms, with or without modification, 
 * provided that the following conditions are met: 
 * - Redistributions of source code must retain the above copyright notice, 
 * this copyright license and the following disclaimer. 
 * - Redistributions in binary form must reproduce the above copyright 
 * notice, this copyright license and the following disclaimer in the 
 * documentation and/or other materials provided with the distribution. 
 * - Neither the name of LiPS  nor the names of its Members may be used 
 * to endorse or promote products derived from the Software without 
 * specific prior written permission. 
 *
 * A patent license for any Necessary Claims owned by Members of LiPS Forum 
 * to make, have made, use, import, offer to sell, lease and sell or otherwise 
 * distribute any implementation compliant with the any specification adopted 
 * by the LiPS Forumcan be obtained from the respective Members on reasonable 
 * and non-discriminatory terms and conditions and under reciprocity, as 
 * regulated in more detail in the Internal Policy of the LiPS Forum. 
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER, ITS MEMBERS AND CONTRIBUTORS 
 * "AS IS", AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, 
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE 
 * AND NON-INFRINGEMENT ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER, 
 * ITS MEMBERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
 * POSSIBILITY OF SUCH DAMAGE. 
 */

/**
 *@file imtype_imp.h
 *API definition of the Instance Message Interface - imtype_imp
 *
 *@version $VERSION$
 *@author ZHAO Liangjing <liangjing.zhao@orange-ft.com>, (C) 2006
 */

#ifndef __LIPS_IM_IMTYPE_IMP_H
#define __LIPS_IM_IMTYPE_IMP_H

#include "imtype.h"
#include "imerror.h"
#include <glib.h>

/**
 *@addtogroup LiPS_IM_API
 *@{
 */

#define IM_TRANS_RID_EVT 0
#define IM_TRANS_RID_LOGIN 1    /// if rid = 1, login transaction
#define IM_TRANS_RID_LOGOUT 2   /// if rid = 2, logout transaction
#define IM_TRANS_RID_WRONG_PASS 3       /// if rid = 3, create login trans failed causing by wrong password.
#define IM_TRANS_RID_INNER_LOGOUT 4     /// if rid = 4, inner logout transaction, no logout event will be triggered
#define IM_TRANS_RID_WRONG_STATE 5      /// if rid = 5, create transaction failed causing by wrong connect state.
#define IM_TRANS_RID_WRONG_SID 6        /// if rid = 6, sid wrong
#define IM_TRANS_RID_NOMEM 7    /// if rid = 7, no memory
#define IM_TRANS_RID_BEGIN 100  /// real transaction rid start from 101

#ifdef __cplusplus
extern "C"
{
#endif                          /* __cplusplus */

  /**
   *@brief for inner usage.
   */
  typedef struct _im_list im_list;

  /**
   *@brief for inner usage.
   */
  //typedef struct _im_hash im_hash;

  im_err_t _im_get_hash_keys (GHashTable *hash, char ***keys);

#ifdef __cplusplus
}
#endif                          /* __cplusplus */

/**@} */

#endif                          /* __LIPS_IM_IMTYPE_IMP_H */

